; #########################################################################
;      Tray Icon Example By TheXROOster 2007
; #########################################################################
.386 ; create 32 bit code
.model flat,stdcall ; 32 bit memory model
option casemap:none ; case sensitive


include \masm32\include\windows.inc 
include \masm32\include\user32.inc 
include \masm32\include\kernel32.inc 
include \masm32\include\shell32.inc 
includelib \masm32\lib\user32.lib 
includelib \masm32\lib\kernel32.lib 
includelib \masm32\lib\shell32.lib

DlgProc		proto		:DWORD,:DWORD,:DWORD,:DWORD 
.const
WM_SHELLNOTIFY equ WM_USER+5
IDI_TRAY                    equ 0
IDM_RESTORE         equ 8000
IDM_ABOUTIT            equ  8013
IDM_EXIT	                    equ 8010
IDM_GOOGLE             equ   8011
IDM_MASM32               equ 8012
.data 
MouseOverMsg  		db "Click Icon To Show Dialog",0
Restore	                            db "&Restore",0
GOOGLE                              db  "&Visit Google",0
MASM32                               db  "&Visit The Masm32 Website",0
AbtString                              db   "&About",0
Close	 	                  db "&Exit",0
GOOGLEV                           db "http://www.google.com/",0;Url For Google.com's Homepage
MASM32V                            db "http://www.masm32.com/",0;Url For The MASM32 Homepage
MsgBoxCaption                 db "About",0; About msgbox Caption
MsgBoxText                        db "This is an example of how to use",10,13; About msgbox Text
                                              db  "          Tray Icons in masm32",0
Operation                            db "open",0; Operation for ShellExecute to use
.data? 

hInstance dd ? 
icodat NOTIFYICONDATA <> ; this deals with the icon and icon status
hPopupMenu dd ?; add this for tray icon menu
.code 
start: 
    invoke GetModuleHandle, NULL 
    mov    hInstance,eax 
    invoke DialogBoxParam, hInstance, 1001, NULL, addr DlgProc, NULL 
    invoke ExitProcess,eax 
    
DlgProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM 
	LOCAL pt:POINT 
	mov	eax,uMsg
	.if	eax == WM_INITDIALOG
                   invoke CreatePopupMenu; Create Menu
		mov hPopupMenu,eax
		invoke AppendMenu,hPopupMenu,MF_STRING,IDM_MASM32,addr MASM32;Addmenu Item IDM_MASM32
		invoke AppendMenu,hPopupMenu,MF_STRING,IDM_GOOGLE,addr GOOGLE;Addmenu Item IDM_GOOGLE
		invoke AppendMenu,hPopupMenu,MF_STRING,IDM_RESTORE,addr Restore;Addmenu Item IDM_RESTORE
		invoke AppendMenu,hPopupMenu,MF_STRING,IDM_ABOUTIT,addr AbtString;Addmenu Item IDM_ABOUTIT
		invoke AppendMenu,hPopupMenu,MF_STRING,IDM_EXIT,addr Close;Addmenu Item IDM_EXIT
		 invoke	LoadIcon,hInstance,200
		invoke	SendMessage, hWnd, WM_SETICON, 1, eax
	.elseif uMsg==WM_DESTROY
		invoke DestroyMenu,hPopupMenu; Remove Menu
		invoke PostQuitMessage,NULL
	.elseif uMsg == WM_COMMAND
		mov     eax, wParam
	; #############################
	; Our Menu Items And there Functions #
	; #############################
		.if wParam == IDM_GOOGLE; If Visit Google Menu Item Clicked
		                invoke ShellExecute, hWnd, addr Operation,addr GOOGLEV , NULL, NULL, SW_SHOWNORMAL;Launch Website
		 .elseif wParam == IDM_RESTORE; If Restore Menu Item Clicked
			       invoke Shell_NotifyIcon,NIM_DELETE,addr icodat;Remove Tray Icon
			       invoke ShowWindow,hWnd,SW_RESTORE;Restore Dialog
		.elseif wParam == IDM_MASM32; If Visit MASM32 Menu Item Clicked
		                invoke ShellExecute, hWnd, addr Operation,addr MASM32V , NULL, NULL, SW_SHOWNORMAL;Launch Website
		.elseif wParam == IDM_EXIT; If Exit Menu Item Clicked
		                invoke DestroyWindow,hWnd;End Proccess
		 .elseif wParam == IDM_ABOUTIT; If About Menu Item Clicked
		                invoke MessageBox, NULL, addr MsgBoxText, addr MsgBoxCaption, MB_OK;Show Message Box
		       .endif
          ; #####################
          ;If Close button is pressed #
	; #####################
          .elseif eax==WM_CLOSE
                     jmp _GOTOTRAY; Jump To _GOTOTRAY
	; ##############################
	;               If Minimize button is pressed #
	; ##############################
	.elseif uMsg==WM_SIZE; Why not use SW_MINIMIZE? Try it when you start the example the tray icon is in the tray at start this is because SW_MIN is ran at start so it doesnt work...
		.if wParam==SIZE_MINIMIZED
                          jmp _GOTOTRAY; Jump To _GOTOTRAY
		.endif
	; ###################
	;Setting up The Tray Icon #
	; ###################
	.elseif uMsg==WM_SHELLNOTIFY
		.if wParam==IDI_TRAY;If the following happens in the Tray...
			.if lParam==WM_RBUTTONDOWN;If Right Mouse button is pressed on the tray
				invoke GetCursorPos,addr pt
				invoke SetForegroundWindow,hWnd
				invoke TrackPopupMenu,hPopupMenu,TPM_RIGHTALIGN or TPM_RIGHTBUTTON,pt.x,pt.y,NULL,hWnd,NULL;Show menu
				invoke PostMessage,hWnd,WM_NULL,0,0
			.elseif lParam==WM_LBUTTONDBLCLK;If Left Mouse Button Is Pressed on the tray
				invoke SendMessage,hWnd,WM_COMMAND,IDM_RESTORE,0;Restore Dialog
			.endif
			.endif
	.elseif	uMsg == WM_CLOSE
		 invoke DestroyWindow,hWnd
	.endif
        
    xor	eax,eax
    ret 
    ; ###################################################################################################
    ;Go To Tray This Line of Code Shortens And Organizes The Rest If you want to go to tray you now just have to add 1 line of code  #
    ; ###################################################################################################
    	_GOTOTRAY:
			mov icodat.cbSize,sizeof NOTIFYICONDATA
			push hWnd
			pop icodat.hwnd
			mov icodat.uID,IDI_TRAY
			mov icodat.uFlags,NIF_ICON+NIF_MESSAGE+NIF_TIP
			mov icodat.uCallbackMessage,WM_SHELLNOTIFY
			invoke LoadIcon,hInstance,200;this is where you define an icon
			mov icodat.hIcon,eax
			invoke lstrcpy,addr icodat.szTip,addr MouseOverMsg;adding Msg to the tray
			invoke ShowWindow,hWnd,SW_HIDE;Hide the open Dialog
			invoke Shell_NotifyIcon,NIM_ADD,addr icodat; Go To Tray
			ret; Return 
DlgProc endp 

end start 


; #########################################################################
;      Tray Icon Example By TheXROOster 2007
; #########################################################################